# -*- coding: utf-8 -*-
"""
Created on Fri Jul 12 21:10:37 2024

@author: micro
"""
from astropy.io import fits

import numpy as np

import matplotlib.pyplot as plt

import matplotlib.dates as mdates
from matplotlib.ticker import MultipleLocator
import matplotlib.cm as mplcm

# import os
# from fnmatch import fnmatch
# import time
import datetime
# from astropy.io import fits
# import cv2
# import rebin







fn = 'D:/WangBing/work/槎山站建设/CBScm/CSO_CBSc_SRSP_L1_20240422T003301_V01.fits'

hdu = fits.open( fn )

data = hdu[0].data

DATE_BEG = hdu[0].header['DATE_BEG']
polar = hdu[0].header[ 'POLARIZA']

dateobs0 = datetime.datetime.fromisoformat(DATE_BEG[0:10] + 'T00:00:00' )

tt = np.ravel( hdu[1].data['time'] )
if tt[0] > 700000 :
    tts = (tt - np.floor(tt[0]) ) * (3600.0*24)
    
ff = np.ravel( hdu[1].data['frequency'] )

hdu.close()
setfontsize = 10
scalemethod = 'linear'
# scalemethod = 'log'
plotv = 1

ZZx = data * 1.0 
 
nt = len(tts)
nff = len(ff)

s2 = dateobs0 + datetime.timedelta( seconds = tts[0] )
s3 = dateobs0 + datetime.timedelta( seconds = tts[-1] )

fr = [ff[0],ff[-1]]     
xr = [tts[0],tts[-1]]     
xx, yy = np.meshgrid(tts, ff) 

minv = 0
maxv = 0.18


if len(data.shape) == 3 :
       ### np.zeros_like( Z0 )
    if scalemethod  == 'log10' :
       ZZx[data>0] = 1.0
       ZZ = np.log10( ZZx )
       Z0 = ZZ[0,:,:]
       Z1 = ZZ[1,:,:]
    else :
       Z0 = ZZx[0,:,:]
       Z1 = ZZx[1,:,:]
    
if len(data.shape) == 2 :
    if scalemethod  == 'log10' :
       ZZx[data>0] = 1.0
       Z0 = np.log10( ZZx )
    else :
       Z0 = ZZx
      
    
    
if plotv == 1:    
    fig,ax1 = plt.subplots(1,1,figsize=( 15, 8 ) )
    titles = 'CSO_CBScm_'+polar + '  ' + DATE_BEG
    fig.suptitle(titles, fontsize= setfontsize)
    
    ax1.set_ylabel('Frequency (GHz)',fontsize = setfontsize )
    # ax1.set_xlabel('Time (UT)',fontsize = setfontsize )
    ax1.set_title( polar ,fontsize = setfontsize, loc = 'right')
    ax1.set_xlim([s2, s3])
    ax1.set_ylim( fr )
                       #ax.xticks(rotation=70)
                       
                       
    ax1.xaxis.set_major_formatter( mdates.DateFormatter('%H:%M:%S'))
    ax1.xaxis.set_minor_locator(mdates.SecondLocator() )
    ax1.yaxis.set_minor_locator(MultipleLocator(10))
    ax1.tick_params(direction='out',  left=True, right = False)
    ax1.tick_params(axis='x', labelsize= setfontsize )
    ax1.tick_params(axis='y', labelsize= setfontsize  )
    ax1.tick_params( which='minor', length=10 )
    ax1.tick_params( which='major', length=20, width =5 ) 
    
    ax1in1 = ax1.inset_axes([0.0, 0.0, 1, 1])

    # maxv = np.max(Z0)
    psm1 = ax1in1.pcolormesh(xx, yy, Z0, vmin=minv, vmax=maxv, cmap ='jet',  rasterized=True)
    ax1in1.axis('off')
    
   
    # cax = fig.add_axes( posbar )
    bar1 = plt.colorbar(psm1, ax = ax1)
    bar1.ax.text(0, maxv+(maxv-minv)/100, scalemethod,fontsize = setfontsize *0.8) 
    bar1.ax.tick_params(direction='out', labelsize=setfontsize*0.8 , right=True)
    bar1.ax.tick_params( which='major', length=10)
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    